package examplos.kafka;

import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;

import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.Producer;
import org.apache.kafka.clients.producer.ProducerConfig;
import org.apache.kafka.clients.producer.ProducerRecord;

public class Editor extends Thread {
	
	public void run() {
		Properties props = new Properties();
		
		//Localização dos servidores kafka (lista de máquinas + porto)
		props.put(ProducerConfig.BOOTSTRAP_SERVERS_CONFIG, "kafka1:9092,kafka2:9092,kafka3:9092");
		
		// Classe para serializar as chaves dos eventos (string)
		props.put(ProducerConfig.KEY_SERIALIZER_CLASS_CONFIG, "org.apache.kafka.common.serialization.StringSerializer");
		
		// Classe para serializar os valores dos eventos (string)
		props.put(ProducerConfig.VALUE_SERIALIZER_CLASS_CONFIG, "org.apache.kafka.common.serialization.StringSerializer");

		// Cria um novo editor (publisher), com as propriedades indicadas acima.
		
		Logger.getAnonymousLogger().log(Level.INFO, "Ligado ao Kafka; Dando inicio ao envio de eventos...");

		try (Producer<String, String> producer = new KafkaProducer<>(props)) {
			for (int i = 0;; i++) {
				//publica eventos, cujo tópico (string) toma alternadamente o valor de: topic0 e topic1.
				producer.send(new ProducerRecord<String, String>("topic" + (i % 2), "chave" + Integer.toString(i),
						"valor:" + Integer.toString(i)));
				sleep(500);
			}
		}		
	}

	static void sleep(int ms) {
		try {
			Thread.sleep(ms);
		} catch (Exception x) {
		}
	}
	
	
	
	public static void main(String[] args) throws Exception {
		
		//Desligar o logging do Kafka...
		//System.setProperty("org.slf4j.simpleLogger.defaultLogLevel", "ALL");
		System.setProperty("org.slf4j.simpleLogger.defaultLogLevel", "OFF");

		
		new Editor().start();
		
		// Correr no docker
		// 1) Se estiverem a correr, correr os servidores externos (zookeeper+kafka+mongo): sh sd17-run-services-toolbox.sh 
		// 2) docker run --network=sd-net -ti isctem-external-services-examplos java -cp /home/sd/* examples.kafka.Editor 

	}

}

