package examplos.mongo;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.bson.Document;

import com.mongodb.MongoClient;
import com.mongodb.MongoClientURI;
import com.mongodb.client.FindIterable;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoDatabase;

public class Mongo {

	private static final String DATABASE = "bd-de-teste";
	private static final String TABELA1 = "uma-tabela";

	public static void main(String[] args) throws Exception {
		//Desligar o logging do Mongo...
		//System.setProperty("org.slf4j.simpleLogger.defaultLogLevel", "ALL");
		System.setProperty("org.slf4j.simpleLogger.defaultLogLevel", "OFF");


		//Indica onde corre a base da dados nosql mongo (3 réplicas) 
		MongoClientURI uri = new MongoClientURI("mongodb://mongo1,mongo2,mongo3/");

		
		//Faz a ligação ao mongo
		try(MongoClient mongo = new MongoClient(uri)) {

			//Obtém referência para uma base de dados...
			MongoDatabase db = mongo.getDatabase(DATABASE);
			
			//Obtém referência para a tabela criada.
			MongoCollection<Document> tabela = db.getCollection( TABELA1 );
			//db.createCollection(TABELA1, new CreateCollectionOptions());
			

		
			//Prepara uma lista de documentos para inserir
			//Um documento corresponde a uma linha da tabela. Visto como um dicionário, as chaves são os atributos/colunas associadoa a cada linha
			List<Document> linhas = new ArrayList<>();	
			for (int i = 0; i < 10; i++) {
				Document doc = new Document();
				doc.put("campo1", "valor" + (i&1));
				doc.put("campo2", 30 + i%3);
				doc.put("data", new Date());
				linhas.add( doc );
			}

			//Insere na tabela uma lista de documentos.
			tabela.insertMany( linhas );
			
			
			//Pesquisa todos os documentos, onde o campo1 tem o valor igual a: valor0 e o campo2 vale 30
			
			Document termo = new Document();
			termo.put("campo1", "valor0");
			termo.put("campo2", 30);

			FindIterable<Document> respostas = tabela.find(termo);

			for( Document doc: respostas ) {
				System.err.println( doc.get("campo1") + "/" + doc.get("data"));
			}

			
			// Correr no docker
			// 1) Correr os servidores externos (zookeeper+kafka+mongo): sh sd17-run-services-toolbox.sh 
			// 2) docker run --network=sd-net -ti isctem-external-services-examplos java -cp /home/sd/* examplos.mongo.Mongo 
			
			
		}
		
	}
	
}
