package examplos.zookeeper;

import java.util.Arrays;
import java.util.List;
import java.util.Random;

public class Main {

	//Exemplo de uma classe com informação a guardar no zookeeper...
	static class Info {
		final int i;
		final String str;
		Info(String str) {
			this.str = str;
			this.i = new Random().nextInt();
		}
		
		public String toString() {
			return "<" + str + ", " + i + ">";
		}
	}
			
	public static void main(String[] args) throws Exception {
		
		//Desligar o logging do Zookeeper...
		//System.setProperty("org.slf4j.simpleLogger.defaultLogLevel", "ALL");
		System.setProperty("org.slf4j.simpleLogger.defaultLogLevel", "OFF");

		Zookeeper zk = new Zookeeper("zoo1,zoo2,zoo3");

		String raiz = "/a/b/c/d";

		zk.criarCaminho(raiz);

		for (String nodo : Arrays.asList("nodo1", "nodo2", "nodo3", "nodo4"))
			zk.gravarValor(raiz + "/" + nodo,  new Info(nodo) );

		List<Info> valores = zk.listarValores(raiz, Info.class);
		System.err.println( valores );
		
		
		// Correr no docker
		// 1) Correr os servidores externos (zookeeper+kafka+mongo): sh sd17-run-services-toolbox.sh 
		// 2) docker run --network=sd-net -ti isctem-external-services-examplos java -cp /home/sd/* examples.zookeeper.Main 
		
	}
}
